/*******************************************
 **  EMUTAG SDK USER CODE BLANK TEMPLATE  **
 *******************************************/

#include <avr/io.h>
#include "main.h"

// OTHER HEADER FILES, INCLUSION FILES, DEFINES, MACROS, GLOBAL VARIABLES, ETC. HERE

/* FUNCTIONS */

/*  user_init() : Called from main code once at boot time. Can be used to initialize memory.
 *              : This function is required to be present. Leave empty if not used.
 */
void user_init(void);

/*  user_proc() : Called from main code when an incoming message has been received and stored in tx_buf[].
 *
 *  rx_bytes      = number of complete bytes stored in tx_buf[]
 *  rx_bits       = number of additional bits received if the last byte is incomplete
 *  rx_bits_total = rx_bytes * 9 + rx_bits, cached for faster comparisons
 *  __attribute__((OS_main)) tells the compiler not to save any registers on stack, as main code reloads everything
 */
void user_proc(uint8_t rx_bytes, uint8_t rx_bits, uint8_t rx_bits_total) __attribute__((OS_main));

// OTHER FUNCTIONS HERE

void user_init(void) {
	
	// INITIALIZATION CODE HERE
	
}

void user_proc(uint8_t rx_bytes, uint8_t rx_bits, uint8_t rx_bits_total) {
	uint8_t tx_start = 0, tx_bits = 0, tx_end = 0; // initialize arguments for reply()
	
	// MESSAGE PROCESSING CODE HERE
	
	// code execution time should fit into timing constraints for timely response
	// response is aligned to 9-bit character frames
	// if timing is not met for a response frame, the response will be transmitted from the next frame
	
	reply(tx_start, tx_bits, tx_end);
	// reply() must be called at the end of user_proc(), even if nothing is to be transmitted!
}	

